---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by Ryann1908.
--- DateTime: 06/02/2020 09:56
--- Sprite by DD at their Twitter (grab link later AAAAAAAAAAAA)
---

--- Player Class
cirno_player = Class(player_class)

--- Initialize
function cirno_player:init()
    lstg.var.ice = 0
    lstg.var.gaugeact = false
    lstg.var.startgauge = false
    LoadTexture('cirno_player', 'THlib\\player\\cirno\\cirno.png')
    LoadImageGroup('cirno_player', 'cirno_player', 0, 0, 32, 48, 8, 3, 0.5, 0.5)
    LoadImage('cirno_support', 'cirno_player', 160, 176, 16, 16)
    LoadImage('cirno_mainshot','cirno_player', 0, 176, 32, 16)
    SetImageState('cirno_mainshot', '', Color(155, 255, 255, 255))
    LoadAnimation('cirno_mainshot_ef', 'cirno_player', 32, 176, 32, 16, 4, 1, 4)
    LoadImage('cirno_pellet','cirno_player', 0, 160, 16, 16)
    SetImageState('cirno_pellet', '', Color(155, 255, 255, 255))
    LoadAnimation('cirno_pellet_ef', 'cirno_player', 16, 160, 16, 16, 4, 1, 4)

    LoadImage('cirno_ice_big', 'cirno_player', 224, 192, 32, 32)
    SetImageState('cirno_ice_big', 'mul+add', Color(185, 255, 255, 255))
    LoadImage('cirno_ice_small', 'cirno_player', 240, 176, 16, 16)
    SetImageState('cirno_ice_small', 'mul+add', Color(255, 255, 255, 255))

    player_class.init(self)
    self.name = 'cirno'
    self.hspeed = 4.5
    self.imgs = {}
    self.A = 0.5 self.B = 0.5
    for i = 1, 24 do self.imgs[i] = 'cirno_player' .. i end
    self.slist =
    {
        {nil, nil, nil, nil},

        {{  0, 40,0,20},               nil,              nil,             nil},
        {{-30,  0,0,20},    { 30, 0, 0,20},              nil,             nil},
        {{-30,  0,0,20},    {  0,-32,0,20},    {30,  0,0,20},             nil},
        {{-30,  0,0,20},    {  0, 32,0,20},    {0, -32,0,20},   {30,  0,0,20}},
        {{-30,  0,0,20},    {  0, 32,0,20},    {0, -32,0,20},   {30,  0,0,20}},
    } --- The options positioning
    New(tasker, function()
        for i = 1, _infinite do
            lstg.var.ice = lstg.var.ice + 1
            task.Wait(60)
        end
    end)
end

--- Shoot
function cirno_player:shoot()
    PlaySound('plst00', 0.3, self.x / 1024)
    self.nextshoot = 4
    New(cirno_main_shot, 'cirno_mainshot', self.x - 10, self.y + 5, 1.7)
    New(cirno_main_shot, 'cirno_mainshot', self.x + 10, self.y + 5, 1.7)
    for i = 1, 4 do
        if self.sp[i] and self.sp[i][3] > 0.5 then
            if self.slow == false then
                New(cirno_option_shot, 'cirno_pellet', self.supportx + self.sp[i][1], self.supporty + self.sp[i][2], 0.55, 10)
            else
                for j = 1, 2 do
                    New(cirno_option_shot, 'cirno_pellet', self.supportx + self.sp[i][1], self.supporty + self.sp[i][2], 0.55 / 2, 16)
                end
            end
        end
    end
end

--- Spell/Bomb
function cirno_player:spell()
    self.nextspell = 310
    self.protect = 320
    self.collect_line = self.collect_line - 300
    New(player_spell_mask, 50, 50, 175, 40, 25, 30)
    misc.ShakeScreen(60, 3)
    PlaySound('power1' ,0.8)
    PlaySound('slash', 0.8)
    self.hspeed = 9
    New(player_smear)
    New(tasker, function()
        task.Wait(300)
        self.collect_line = self.collect_line + 300
        self.hspeed = 4.5
    end)
    local a, _d_a = (ran:Int(0, 360)), (360 / 8)
    for _ = 1, 8 do
        New(cirno_trail_head, self.x, self.y, a)
        a = a + _d_a
    end

    local a, _d_a = (ran:Int(0, 360)), (360 / 55)
    for _ = 1, 55 do
        New(cirno_bomb_shot, 'cirno_pellet', self.x, self.y, 0.30, 3, a)
        a = a + _d_a
    end

    for _ = 1, 55 do
        New(cirno_bomb_shot, 'cirno_pellet', self.x, self.y, 0.30, 1.5, a)
        a = a + _d_a
    end
end


--- Special (for example, releases (key C)); this is commented out, but you can try uncommenting it and press C to drop some items
function cirno_player:special()
    if lstg.var.ice >= 200 then
        if self.slow == false then
            New(cirno_ice_special, 'cirno_ice_big', self.x, self.y, 90 - 20)
            New(cirno_ice_special, 'cirno_ice_big', self.x, self.y, 90)
            New(cirno_ice_special, 'cirno_ice_big', self.x, self.y, 90 + 20)
        else
            New(cirno_ice_special, 'cirno_ice_big', self.x, self.y, 90 - 10)
            New(cirno_ice_special, 'cirno_ice_big', self.x, self.y, 90)
            New(cirno_ice_special, 'cirno_ice_big', self.x, self.y, 90 + 10)
        end
        self.nextsp = 60
        PlaySound('ice', 1, self.x / 256)
        lstg.var.ice = lstg.var.ice - 200
        lstg.var.startgauge = true
    end
end


--- Rendering of the player code and options
function cirno_player:render()
    for i = 1, 4 do
        if self.sp[i] and self.sp[i][3] > 0.5 then
            Render('cirno_support', self.supportx + self.sp[i][1], self.supporty + self.sp[i][2], self.timer * 3) --- Rendering of the options
        end
    end
    player_class.render(self) --- Renders the player
end

------------------------------------------ Objects/Shots/Bombs/Effects
--- Main Shot

cirno_main_shot = Class(object)
function cirno_main_shot:init(img, x, y, dmg)
    self.x = x
    self.y = y
    self.group = GROUP_PLAYER_BULLET
    self.layer = LAYER_PLAYER_BULLET
    self.img = img
    self.hscale = 1.1
    self.vscale = 1.1
    self.a = 50
    self.b = 20
    self.rot = 90
    self.dmg = dmg
    self.bound = false
    self.killflag = false
    self.vy = 20
end

function cirno_main_shot:frame()
    if self.timer > 5 then
        self.bound = true
    end
end

function cirno_main_shot:kill()
    New(cirno_main_shot_ef, 'cirno_mainshot_ef', self.x, self.y)
    Kill(self)
end

--- Main Shot Effect (when killed)

cirno_main_shot_ef = Class(object) --- The main shot's effect, it is an object (object class)
function cirno_main_shot_ef:init(img, x, y)
    self.x = x
    self.y = y
    self.img = img
    self.hscale = 1.4
    self.vscale = 1.4
    self.rot = ran:Int(85,95)
    self.vy = 1
    SetImgState(self, 'mul+add', 255, 155, 155, 255)
end

function cirno_main_shot_ef:frame()
    if self.timer > 19 then
        Kill(self)
    end
end

--- Option Shot

cirno_option_shot = Class(object)
function cirno_option_shot:init(img, x, y, dmg, speed)
    self.x = x
    self.y = y
    self.group = GROUP_PLAYER_BULLET
    self.layer = LAYER_PLAYER_BULLET
    self.img = img
    self.hscale = 1.1
    self.vscale = 1.1
    self.a = 50
    self.b = 20
    self.rot = ran:Int(80, 100)
    self.dmg = dmg
    self.bound = false
    self.killflag = false
    self.v = speed
    SetV2(self, self.v, self.rot)
end

function cirno_option_shot:frame()
    if self.timer > 5 then
        self.bound = true
    end
end

function cirno_option_shot:kill()
    New(cirno_option_shot_ef, 'cirno_pellet_ef', self.x, self.y)
    Kill(self)
end

--- Option Shot Effect (when killed)

cirno_option_shot_ef = Class(object)
function cirno_option_shot_ef:init(img, x, y)
    self.x = x
    self.y = y
    self.img = img
    self.hscale = 1.4
    self.vscale = 1.4
    self.rot = ran:Int(85,95)
    self.vy = 1
    SetImgState(self, 'mul+add', 255, 155, 155, 255)
end

function cirno_option_shot_ef:frame()
    if self.timer > 19 then
        Kill(self)
    end
end

--- Bomb

cirno_trail_head = Class(object)
function cirno_trail_head:init(x, y, ang)
    self.x = x
    self.y = y
    self.bound = false
    self.killflag = false
    self.rot = ang
    self.group = GROUP_PLAYER_BULLET
    self.a = 32
    self.b = 32
    self.dmg = 4
    self.killflag = true
    SetV2(self, ran:Float(3, 3.8), ang)
    lstg.var.shootice = false
end

function cirno_trail_head:frame()
    if self.timer % 4 == 0 then
        New(cirno_ice_trail, 'cirno_ice_big', self.x, self.y)
    end
    if self.timer > 180 then Kill(self) end
    if self.timer % 8 == 0 then
        --self.rot = self.rot + ran:Int(-2, 2)
        SetV2(self, ran:Float(3, 3.8), self.rot + ran:Int(-30, 30))
    end
    if self.timer > 5 then self.bound = true end
end

cirno_ice_trail = Class(object)
function cirno_ice_trail:init(img, x, y)
    self.x = x
    self.y = y
    self.group = GROUP_PLAYER
    --self.layer = LAYER_PLAYER
    self.img = img
    self.a = 32
    self.b = 32
    self.colli = true
    self.hscale = ran:Float(1, 1.6)
    self.vscale = ran:Float(1, 1.6)
    self.rot = ran:Int(0, 360)
    self.bound = false
    self.killflag = false
    task.New(self, function()
        local _beg_scale = ran:Float(3, 4)
        local scale = _beg_scale
        local _w_scale = 0
        local _end_scale = ran:Float(1, 1.5)
        local _d_w_scale = 90 / (25 - 1)
        for _ = 1, 25 do
            self.hscale, self.vscale = scale, scale
            task._Wait(1)
            _w_scale = _w_scale + _d_w_scale
            scale = (_end_scale - _beg_scale) * sin(_w_scale) + (_beg_scale)
        end
        task.Wait(155)
        PlaySound('ice2', 1, self.x / 1024)
        New(bubble, 'parimg9', self.x, self.y, 10, 2, 4, Color(0xFF9EFFF6), Color(0x10FFFFFF), LAYER_PLAYER + 5)
        Kill(self)
    end)
end

function cirno_ice_trail:frame()
    task.Do(self)
end

function cirno_ice_trail:colli(other)
    if other.group == GROUP_ENEMY_BULLET or other.group == GROUP_INDES then
        if Dist(self, other) < 16 then
            SetV2(other, 0, other.rot)
            if not other.iced then
                PlaySound('ice', 1, self.x / 1024)
                New(cirno_ice_trail_freeze, 'cirno_ice_small', other.x, other.y, 180 - self.timer)
                lstg.var.ice = lstg.var.ice + 1
            end
            task.Clear(other, false)
            other.iced = true
            task.New(other, function()
                if IsValid(self) then
                    other.icetime = 180 - self.timer
                else
                    other.icetime = 1
                end
                local ic = 0
                for i = 1, _infinite do
                    if other.icetime == 0 then

                        local a, _d_a = (ran:Int(0, 360)), (360 / 8)
                        for _ = 1, 8 do
                            New(cirno_bomb_shot, 'cirno_pellet', other.x, other.y, 0.30, 10, a)
                            a = a+_d_a
                        end
                        Kill(other)
                        break

                    end

                    other.icetime = other.icetime - 1
                    task.Wait(1)
                end
            end)
        end
    end
end

cirno_ice_trail_freeze = Class(object)
function cirno_ice_trail_freeze:init(img, x, y, timespan)
    self.x = x
    self.y = y
    self.group = GROUP_PLAYER
    --self.layer = LAYER_PLAYER
    self.img = img
    self.a = 16
    self.b = 16
    self.colli = true
    self.hscale = ran:Float(1, 1.6)
    self.vscale = ran:Float(1, 1.6)
    self.rot = ran:Int(0, 360)
    self.bound = false
    self.killflag = false
    self.timespan = timespan
end

function cirno_ice_trail_freeze:frame()
    if self.timer > self.timespan then
        New(bubble, 'parimg9', self.x, self.y, 4, 1, 2, Color(0xFF9EFFF6), Color(0x10FFFFFF), LAYER_PLAYER + 5)
        Kill(self)
    end
end

cirno_bomb_shot = Class(object)
function cirno_bomb_shot:init(img, x, y, dmg, speed, rot)
    self.x = x
    self.y = y
    self.group = GROUP_PLAYER_BULLET
    self.layer = LAYER_PLAYER_BULLET
    self.img = img
    self.hscale = 1.1
    self.vscale = 1.1
    self.a = 50
    self.b = 20
    self.rot = rot
    self.dmg = dmg
    self.bound = false
    self.killflag = false
    self.v = speed
    SetV2(self, self.v, self.rot)
end

function cirno_bomb_shot:frame()
    if self.timer > 5 then
        self.bound = true
    end
end

function cirno_bomb_shot:kill()
    New(cirno_option_shot_ef, 'cirno_pellet_ef', self.x, self.y, self.rot)
    Kill(self)
end

--- Option Shot Effect (when killed)

cirno_bomb_shot_ef = Class(object)
function cirno_bomb_shot_ef:init(img, x, y, rot)
    self.x = x
    self.y = y
    self.img = img
    self.hscale = 1.4
    self.vscale = 1.4
    self.rot = rot + ran:Int(15, -15)
    SetV2(self, 1, self.rot)
    SetImgState(self, 'mul+add', 255, 155, 155, 255)
end

function cirno_bomb_shot_ef:frame()
    if self.timer > 19 then
        Kill(self)
    end
end

player_smear = Class(object)
function player_smear:init()
    self.img = player.img
    self.layer = LAYER_PLAYER - 1
    self.group = GROUP_PLAYER
    self.x = player.x
    self.y = player.y
    New(smear, self, 1)
end

function player_smear:frame()
    if self.timer > 300 then Kill(self) end
    self.img = player.img
    self.x = player.x
    self.y = player.y
    --New(smear, self, 4)
end




cirno_ice_special = Class(object)
function cirno_ice_special:init(img, x, y, ang)
    self.x = x
    self.y = y
    self.group = GROUP_PLAYER
    --self.layer = LAYER_PLAYER
    self.img = img
    self.a = 32
    self.b = 32
    self.colli = true
    self.hscale = ran:Float(1, 1.6)
    self.vscale = ran:Float(1, 1.6)
    self.rot = ran:Int(0, 360)
    self.bound = false
    self.killflag = false
    SetV2(self, 5, ang, false, false)
    task.New(self, function()
        local _beg_scale = ran:Float(3, 4)
        local scale = _beg_scale
        local _w_scale = 0
        local _end_scale = ran:Float(1, 1.5)
        local _d_w_scale = 90 / (25 - 1)
        for _ = 1, 25 do
            self.hscale, self.vscale = scale, scale
            task._Wait(1)
            _w_scale = _w_scale + _d_w_scale
            scale = (_end_scale - _beg_scale) * sin(_w_scale) + (_beg_scale)
        end
        task.Wait(155)
        PlaySound('ice2', 1, self.x / 1024)
        New(bubble, 'parimg9', self.x, self.y, 10, 2, 4, Color(0xFF9EFFF6), Color(0x10FFFFFF), LAYER_PLAYER + 5)
        Kill(self)
    end)
end

function cirno_ice_special:frame()
    task.Do(self)
end

function cirno_ice_special:colli(other)
    if other.group == GROUP_ENEMY_BULLET or other.group == GROUP_INDES then
        if Dist(self, other) < 16 then
            SetV2(other, 0, other.rot)
            if not other.iced then
                PlaySound('ice', 1, self.x / 1024)
                New(cirno_ice_trail_freeze, 'cirno_ice_small', other.x, other.y, 180 - self.timer)
                lstg.var.ice = lstg.var.ice + 1
            end
            task.Clear(other, false)
            other.iced = true
            task.New(other, function()
                if IsValid(self) then
                    other.icetime = 180 - self.timer
                else
                    other.icetime = 1
                end
                local ic = 0
                for i = 1, _infinite do
                    if other.icetime == 0 then

                        local a, _d_a = (ran:Int(0, 360)), (360 / 8)
                        for _ = 1, 8 do
                            New(cirno_bomb_shot, 'cirno_pellet', other.x, other.y, 0.30, 10, a)
                            a = a+_d_a
                        end
                        Kill(other)
                        break

                    end

                    other.icetime = other.icetime - 1
                    task.Wait(1)
                end
            end)
        end
    end
end